#include <algorithm>
#include <cstdint>
#include <cstdio>
#include <random>
#include <vector>


using u32 = std::uint_fast32_t;

u32 N = u32(1) << 28;
long C = N >> 10;

template <typename RandomIt>
void sequential_shuffle(RandomIt first, RandomIt last)
{
  auto it = first;
  for (; it < last; it += C) {
    std::shuffle(it, it + C, std::mt19937{std::random_device{}()});
  }
  if (it < last)
  {
    std::shuffle(it, last, std::mt19937{std::random_device{}()});
  }
}

int main() {
  std::vector<u32> v;
  v.reserve(N);
  for (u32 i = 0; i < N; i++) {
    v.push_back(i);
  }
  sequential_shuffle(v.begin(), v.end());
  printf("v[0] = %lu\n", v[0]);
  puts("done");
}
